package immibis.core.porting;

/* $if mc == 1.2.5 && jclient$ */

import immibis.core.mod_ImmibisCore;
import immibis.core.api.porting.IClientPacketHandler;
import immibis.core.api.porting.IServerPacketHandler;
import immibis.core.api.porting.PortableBaseMod;
import immibis.core.api.porting.PortableBlockRenderer;
import immibis.core.api.porting.PortableGuiHandler;
import immibis.core.api.porting.SidedProxy;
import immibis.core.aspects.ClientOnly;

import java.io.File;

import net.minecraft.src.*;
import net.minecraft.src.forge.*;

@ClientOnly
public class ClientProxy125 extends SidedProxy {

	@Override
	public File getMinecraftDir() {
		return ModLoader.getMinecraftInstance().mcDataDir;
	}

	@Override
	public void addLocalization(String key, String value) {
		ModLoader.addLocalization(key, value);
	}

	@Override
	public void sendChat(String msg, EntityPlayer player) {
		if(player == ModLoader.getMinecraftInstance().thePlayer)
			ModLoader.getMinecraftInstance().ingameGUI.addChatMessage(msg);
	}

	@Override
	public double getPlayerReach(EntityPlayer ply) {
		return ModLoader.getMinecraftInstance().playerController.getBlockReachDistance();
	}

	@Override
	public EntityPlayer getThePlayer() {
		return ModLoader.getMinecraftInstance().thePlayer;
	}

	@Override
	public int getUniqueBlockModelID(String renderClass, boolean b) {
		try {
			PortableBlockRenderer r = (PortableBlockRenderer)Class.forName(renderClass).getConstructor().newInstance();
			int model = ModLoader.getUniqueBlockModelID(mod_ImmibisCore.instance, b);
			mod_ImmibisCore.setRenderer(model, r);
			return model;
		} catch(Exception e) {
			throw new RuntimeException(e);
		}
	}

	@Override
	public boolean isOp(String player) {
		return !ModLoader.getMinecraftInstance().theWorld.isRemote;
	}

	@Override
	public void preloadTexture(String texfile) {
		MinecraftForgeClient.preloadTexture(texfile);
	}

	@Override
	public void registerTileEntity(Class<? extends TileEntity> clazz, String id, String rclass) {
		try {
			TileEntitySpecialRenderer r = (TileEntitySpecialRenderer)Class.forName(rclass).getConstructor().newInstance();
			ModLoader.registerTileEntity(clazz, id, r);
		} catch(Exception e) {
			throw new RuntimeException(e);
		}
	}

	@Override
	public boolean isWorldCurrent(World w) {
		return w == ModLoader.getMinecraftInstance().theWorld;
	}

	@Override
	public void registerItemRenderer(int itemID, String renderClassName) {
		try {
			IItemRenderer r = Class.forName(renderClassName).asSubclass(IItemRenderer.class).getConstructor().newInstance();
			MinecraftForgeClient.registerItemRenderer(itemID, r);
		} catch(Exception e) {
			throw new RuntimeException(e);
		}
	}

	@Override
	public void registerServerPacketHandler(String channel, IServerPacketHandler handler) {
	}

	@Override
	public void registerClientPacketHandler(final String channel, final IClientPacketHandler handler) {
		MinecraftForge.registerConnectionHandler(new IConnectionHandler() {
			
			public void onConnect(NetworkManager network) {
				MessageManager.getInstance().registerChannel(network, new IPacketHandler() {
					@Override
					public void onPacketData(NetworkManager network, String channel_, byte[] data) {
						handler.onPacketData(channel_, data);
					}
				}, channel);
			}

		    public void onLogin(NetworkManager network, Packet1Login login) {
		    	
		    }

		    public void onDisconnect(NetworkManager network, String message, Object[] args) {
		    	
		    }
		});
	}

	@Override
	public void sendPacket(Packet250CustomPayload wrap, EntityPlayer player) {
		ModLoader.getMinecraftInstance().getSendQueue().addToSendQueue(wrap);
	}

	@Override
	public void setGuiHandler(PortableBaseMod mod, PortableGuiHandler handler) {
		MinecraftForge.setGuiHandler(mod, handler);
	}

	@Override
	public boolean isClient(Entity e) {
		return true;
	}

	@Override
	public boolean isServer(Entity e) {
		return !e.worldObj.isRemote;
	}

	@Override
	public boolean isDedicatedServer() {
		return false;
	}
	
	@Override
	public Vec3D createVector(IBlockAccess world, double x, double y, double z) {
		return Vec3D.createVector(x, y, z);
	}
}

/* $endif$ */
